c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine kernel(drx,dry,drz,i,j,j1,j2,rr2)

      include 'common.3D'   

      index_tensile= 1
      gauss=1.
      gauss2=gauss*gauss

c		Gaussian 3D Kernel

      rad = sqrt(rr2)
      qq  = rad/h

      Wab = a2*exp(-qq*qq/gauss2)
      fac = f1*qq*exp(-qq*qq/gauss2)/rad

      frx = fac * drx
      fry = fac * dry
      frz = fac * drz


c     Sum_wab to calculate the normalized kernel
      if(j.gt.nstart_minus1)then
        V_j = pVol(j)  !=pm(j)/rhop(j)
        sum_wab(i)  = sum_wab(i)  + Wab*V_j   !pm(j)/rhop(j)	
        rhop_sum(i) = rhop_sum(i) + pm(j)*Wab       
        !sum_dWdx(i) = sum_dWdx(i) - frx*drx*V_j
        !sum_dWdy(i) = sum_dWdy(i) - frx*dry*V_j
        !sum_dWdz(i) = sum_dWdz(i) - frz*drz*V_j
      end if

      if(i.gt.nstart_minus1)then			  
        V_i = pVol(i)   !=pm(i)/rhop(i)
        sum_wab(j)  = sum_wab(j)  + Wab*V_i 
        rhop_sum(j) = rhop_sum(j) + pm(i)*Wab       
        !sum_dWdx(j) = sum_dWdx(j) - frx*drx*V_i
        !sum_dWdy(j) = sum_dWdy(j) - frx*dry*V_i
        !sum_dWdz(j) = sum_dWdz(j) - frz*drz*V_i
      endif


      return 
      end